/* ==========================================================================*/
/* - - - - - - - - - - - - -  T i m e r . c  - - - - - - - - - - - - - - - - */
/* ==========================================================================*/
/*	Created   2005-11-03   M. Wheatley                                       */
/*	Modified  2006-11-16   MW                                                */
/*.........................................................................  */
/* DV Dongle AT91SAM7256 Bootloader Timer                                    */
//////////////////////////////////////////////////////////////////////////////
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//////////////////////////////////////////////////////////////////////////////

/*---------------------------------------------------------------------------*/
/*------------------------> I N C L U D E S <--------------------------------*/
/*---------------------------------------------------------------------------*/
#include "board.h"
#include "timer.h"
#include "AT91SAM7S256.h"
#define __inline static inline
#include "lib_AT91SAM7S256.h"

/*---------------------------------------------------------------------------*/
/*--------------------> L O C A L   D E F I N E S <--------------------------*/
/*---------------------------------------------------------------------------*/
/*-----------------*/
/* Clock Selection */
/*-----------------*/
#define TC_CLKS                  0x7
#define TC_CLKS_MCK2             0x0
#define TC_CLKS_MCK8             0x1
#define TC_CLKS_MCK32            0x2
#define TC_CLKS_MCK128           0x3
#define TC_CLKS_MCK1024          0x4


/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*                      -------------------                                  */
/*                     | T i m e r I n i t |                                 */
/*                      -------------------                                  */
/*    Called to initialize the Timer.                                        */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
void TimerInit ( void )
{
int dummy;
    //* Open timer0
	//* First, enable the clock of the TIMER
	AT91F_PMC_EnablePeriphClock ( AT91C_BASE_PMC, 1<<AT91C_ID_TC0 ) ;
	//* Disable the clock and the interrupts
	AT91C_BASE_TC0->TC_CCR = AT91C_TC_CLKDIS;
	AT91C_BASE_TC0->TC_IDR = 0xFFFFFFFF ;
	//* Clear status bit
	dummy = AT91C_BASE_TC0->TC_SR;
	//* Suppress warning variable "dummy" was set but never used
	 dummy = dummy;
	//* Set the Mode of the Timer Counter
	AT91C_BASE_TC0->TC_CMR = TC_CLKS_MCK32; //~23Hz

	//* Enable the clock
	AT91C_BASE_TC0->TC_CCR = AT91C_TC_CLKEN ;

	//* Start timer0
	AT91C_BASE_TC0->TC_CCR = AT91C_TC_SWTRG ;
}
